# Painikepeli Frontend 2020

## Tavoite
Tavoitteena on toteuttaa yksinkertainen moninpeli, jota pelataan painamalla painiketta. Painikkeen painaminen maksaa yhden pisteen, joita pelaajalla on lähtötilanteessa 20. Painiketta voi painaa vain, jos pelaajan pistesaldo on positiivinen. Pelaajan painettua painiketta hänelle ilmoitetaan mahdollisesta voitosta.

Pelaaja voittaa
* 5 pistettä joka 10. painallus
* 40 pistettä joka 100. painallus
* 250 pistettä joka 500. painallus.

Pelaaja voi voittaa enimmillään yhden palkinnon yhdellä painalluksella. Mikäli samalla painalluksella voittaisi yllä olevan listan mukaan monta palkintoa, voittaa pelaaja näistä suurimman. Painiketta painaessa pelaaja ei tiedä, mikä laskurin nykyinen arvo on, sillä kaikki pelaajat kasvattavat saman laskurin arvoa.

Kun pelaaja painaa painiketta, tapahtuu seuraavat asiat:
1. Pelaajalta vähennetään yksi piste.
2. Laskurin arvo kasvaa yhdellä.
3. Mikäli laskurin arvolle osuu palkinto (esim. laskurin arvolla 500 voittaa 250 pistettä), ilmoitetaan tästä pelaajalle ja lisätään voitto pelaajan pistesaldoon.
4. Pelaajalle näytetään vaadittujen painallusten määrä seuraavaan voittavaan arvoon.

Pelin käyttöliittymässä tulee näkyä pelaajan pistesaldo. Pelitilanteen tulee säilyä, vaikka selaimen (mikäli selainsovellus) tai sovelluksen (mikäli mobiilisovellus) käynnistää uudelleen. Mikäli pelaajan pistesaldo on 0, tarjotaan pelaajalle mahdollisuus aloittaa alusta, jolloin hänen pistesaldonsa palautetaan jälleen arvoon 20.
Sovellus koostuu kahdesta osasta: käyttöliittymästä ja palvelimesta.
Pelin käyttöliittymä voidaan toteuttaa joko selain- tai mobiilisovelluksena. Selainsovelluksen toivotaan olevan tehty nykyaikaisilla työkaluilla, kuten Reactilla, Vuella tai Angularilla. Mobiilisovellus voi olla Android-, iOS- tai hybridisovellus.
Palvelinsovelluksen voit toteuttaa haluamillasi teknologioilla. On toivottavaa, että palvelin olisi julkisesti saatavilla jossakin pilvipalvelussa. Esimerkiksi Heroku tarjoaa ilmaisen testipalvelimen, mutta voit käyttää halutessasi myös muita palveluntarjoajia.
Lähetä kotitehtävä meille esim. linkkinä GitHub-repositorioon tai liitetiedostona (.zip).
Versionhallinnan tai liitetiedoston tulee sisältää kaikki sellaiset tiedostot ja ohjeet, jotka vaaditaan sovelluksen kääntämiseen ja käynnistämiseen. Kiinnitä huomiota erityisesti toteutuksen selkeyteen ja johdonmukaisuuteen.

## Frontendin skriptit

Projectin kansiossa on käytettävissä seuraavat skriptit:

### `npm start`

Runs the app in the development mode.<br />
Open [http://localhost:3000](http://localhost:3000) to view it in the browser.

The page will reload if you make edits.<br />
You will also see any lint errors in the console.

### `npm test`

Launches the test runner in the interactive watch mode.<br />
See the section about [running tests](https://facebook.github.io/create-react-app/docs/running-tests) for more information.

### `npm build`

Builds the app for production to the `build` folder.<br />
It correctly bundles React in production mode and optimizes the build for the best performance.

The build is minified and the filenames include the hashes.<br />
Your app is ready to be deployed!

See the section about [deployment](https://facebook.github.io/create-react-app/docs/deployment) for more information.

### `npm eject`

**Note: this is a one-way operation. Once you `eject`, you can’t go back!**

If you aren’t satisfied with the build tool and configuration choices, you can `eject` at any time. This command will remove the single build dependency from your project.

Instead, it will copy all the configuration files and the transitive dependencies (Webpack, Babel, ESLint, etc) right into your project so you have full control over them. All of the commands except `eject` will still work, but they will point to the copied scripts so you can tweak them. At this point you’re on your own.

You don’t have to ever use `eject`. The curated feature set is suitable for small and middle deployments, and you shouldn’t feel obligated to use this feature. However we understand that this tool wouldn’t be useful if you couldn’t customize it when you are ready for it.

## Docker komennot



## Learn More

You can learn more in the [Create React App documentation](https://facebook.github.io/create-react-app/docs/getting-started).

To learn React, check out the [React documentation](https://reactjs.org/).

### Code Splitting

This section has moved here: https://facebook.github.io/create-react-app/docs/code-splitting

### Analyzing the Bundle Size

This section has moved here: https://facebook.github.io/create-react-app/docs/analyzing-the-bundle-size

### Making a Progressive Web App

This section has moved here: https://facebook.github.io/create-react-app/docs/making-a-progressive-web-app

### Advanced Configuration

This section has moved here: https://facebook.github.io/create-react-app/docs/advanced-configuration

### Deployment

This section has moved here: https://facebook.github.io/create-react-app/docs/deployment

### `yarn build` fails to minify

This section has moved here: https://facebook.github.io/create-react-app/docs/troubleshooting#npm-run-build-fails-to-minify
